# dvbsrc

dvbsrc can be used to capture media from DVB cards. Supported DTV broadcasting standards include DVB-T/C/S, ATSC, ISDB-T and DTMB.

## Example launch line

     gst-launch-1.0 dvbsrc modulation="QAM 64" trans-mode=8k bandwidth=8 frequency=514000000 code-rate-lp=AUTO code-rate-hp=2/3 guard=4  hierarchy=0 ! mpegtsdemux name=demux ! queue max-size-buffers=0 max-size-time=0 ! mpegvideoparse ! mpegvideoparse ! mpeg2dec ! xvimagesink demux. ! queue max-size-buffers=0 max-size-time=0 ! mpegaudioparse ! mpg123audiodec ! audioconvert ! pulsesink

Captures a full transport stream from DVB card 0 that is a DVB-T card at tuned frequency 514000000 Hz with other parameters as seen in the pipeline and renders the first TV program on the transport stream.

     gst-launch-1.0 dvbsrc modulation="QAM 64" trans-mode=8k bandwidth=8 frequency=514000000 code-rate-lp=AUTO code-rate-hp=2/3 guard=4  hierarchy=0 pids=100:256:257 ! mpegtsdemux name=demux ! queue max-size-buffers=0 max-size-time=0 ! mpegvideoparse ! mpeg2dec ! xvimagesink demux. ! queue max-size-buffers=0 max-size-time=0 ! mpegaudioparse ! mpg123audiodec ! audioconvert ! pulsesink

Captures and renders a transport stream from DVB card 0 that is a DVB-T card for a program at tuned frequency 514000000 Hz with PMT PID 100 and elementary stream PIDs of 256, 257 with other parameters as seen in the pipeline.

     gst-launch-1.0 dvbsrc polarity="h" frequency=11302000 symbol-rate=27500 diseqc-source=0 pids=50:102:103 ! mpegtsdemux name=demux ! queue max-size-buffers=0 max-size-time=0 ! mpegvideoparse ! mpeg2dec ! xvimagesink demux. ! queue max-size-buffers=0 max-size-time=0 ! mpegaudioparse ! mpg123audiodec ! audioconvert ! pulsesink

Captures and renders a transport stream from DVB card 0 that is a DVB-S card for a program at tuned frequency 11302000 kHz, symbol rate of 27500 kBd (kilo bauds) with PMT PID of 50 and elementary stream PIDs of 102 and 103.

     gst-launch-1.0 dvbsrc frequency=515142857 guard=16 trans-mode="8k" isdbt-layer-enabled=7 isdbt-partial-reception=1 isdbt-layera-fec="2/3" isdbt-layera-modulation="QPSK" isdbt-layera-segment-count=1 isdbt-layera-time-interleaving=4 isdbt-layerb-fec="3/4" isdbt-layerb-modulation="qam-64" isdbt-layerb-segment-count=12 isdbt-layerb-time-interleaving=2 isdbt-layerc-fec="1/2" isdbt-layerc-modulation="qam-64" isdbt-layerc-segment-count=0 isdbt-layerc-time-interleaving=0 delsys="isdb-t" ! tsdemux ! "video/x-h264" ! h264parse ! queue ! avdec_h264 ! videoconvert ! queue ! autovideosink

Captures and renders the video track of TV Paraíba HD (Globo affiliate) in Campina Grande, Brazil. This is an ISDB-T (Brazilian ISDB-Tb variant) broadcast.

      gst-launch-1.0 dvbsrc frequency=503000000 delsys="atsc" modulation="8vsb" pids=48:49:52 ! decodebin name=dec dec. ! videoconvert ! autovideosink dec. ! audioconvert ! autoaudiosink

Captures and renders KOFY-HD in San Jose, California. This is an ATSC broadcast, PMT ID 48, Audio/Video elementary stream PIDs 49 and 52 respectively.

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseSrc
                        ╰──GstPushSrc
                            ╰──dvbsrc

## Factory details

Authors: – P2P-VCR, C-Lab, University of Paderborn, Zaheer Abbas Merali <zaheerabbas at merali dot org>, Reynaldo H. Verdejo Pinochet <reynaldo></reynaldo></zaheerabbas>

Classification: – `Source/Video`

Rank – none

Plugin – dvb

Package – GStreamer Bad Plug-ins

## Pad Templates

### `src`

    video/mpegts:
        mpegversion: 2
       systemstream: true

Presence – always

Direction – src

Object type – GstPad

## Signals

### tuning-done

    tuning_done_callback (GstElement * gstdvbsrc,
                          gpointer udata)

    def tuning_done_callback (gstdvbsrc, udata):
        #python callback for the 'tuning-done' signal

    function tuning_done_callback(gstdvbsrc: GstElement * gstdvbsrc, udata: gpointer udata): {
        // javascript callback for the 'tuning-done' signal
    }

Signal emitted when the tunner has successfully got a lock on a signal.

Parameters:

`gstdvbsrc` –

the element on which the signal is emitted

`udata` –
No description available

Flags: Run Last

### tuning-fail

    tuning_fail_callback (GstElement * gstdvbsrc,
                          gpointer udata)

    def tuning_fail_callback (gstdvbsrc, udata):
        #python callback for the 'tuning-fail' signal

    function tuning_fail_callback(gstdvbsrc: GstElement * gstdvbsrc, udata: gpointer udata): {
        // javascript callback for the 'tuning-fail' signal
    }

Signal emitted when the tunner failed to get a lock on the signal.

Parameters:

`gstdvbsrc` –

the element on which the signal is emitted

`udata` –
No description available

Flags: Run Last

### tuning-start

    tuning_start_callback (GstElement * gstdvbsrc,
                           gpointer udata)

    def tuning_start_callback (gstdvbsrc, udata):
        #python callback for the 'tuning-start' signal

    function tuning_start_callback(gstdvbsrc: GstElement * gstdvbsrc, udata: gpointer udata): {
        // javascript callback for the 'tuning-start' signal
    }

Signal emitted when the element first attempts to tune the frontend tunner to a given frequency.

Parameters:

`gstdvbsrc` –

the element on which the signal is emitted

`udata` –
No description available

Flags: Run Last

## Action Signals

### tune

    g_signal_emit_by_name (gstdvbsrc, "tune");

    ret = gstdvbsrc.emit ("tune")

    let ret = gstdvbsrc.emit ("tune");

Signal emitted from the application to the element, instructing it to tune.

Parameters:

`gstdvbsrc` (GstElement *) –

the element on which the signal is emitted

Flags: Run Last / Action

## Properties

### adapter

    “adapter” gint

The DVB adapter device number (eg. 0 for adapter0)

Flags : Read / Write

Default value : 0

### bandwidth

    “bandwidth” GstDvbSrcBandwidth *

(DVB-T) Bandwidth. Deprecated

Flags : Read / Write

Default value : AUTO (3)

### bandwidth-hz

    “bandwidth-hz” guint

Channel bandwidth in Hz

Flags : Read / Write

Default value : 0

### code-rate-hp

    “code-rate-hp” GstDvbSrcCode_Rate *

(DVB-T, DVB-S/S2 and DVB-C) High priority code rate

Flags : Read / Write

Default value : auto (9)

### code-rate-lp

    “code-rate-lp” GstDvbSrcCode_Rate *

(DVB-T) Low priority code rate

Flags : Read / Write

Default value : 1/2 (1)

### delsys

    “delsys” GstDvbSrcDelsys *

Delivery System

Flags : Read / Write

Default value : undefined (0)

### diseqc-source

    “diseqc-source” gint

(DVB-S/S2) Selected DiSEqC source. Only needed if you have a DiSEqC switch. Otherwise leave at -1 (disabled)

Flags : Read / Write

Default value : -1

### dvb-buffer-size

    “dvb-buffer-size” guint

The kernel buffer size used by the DVB api

Flags : Read / Write

Default value : 1925120

### frequency

    “frequency” guint

Center frequency to tune into. Measured in kHz for the satellite distribution standards and Hz for all the rest

Flags : Read / Write

Default value : 0

### frontend

    “frontend” gint

The frontend device number (eg. 0 for frontend0)

Flags : Read / Write

Default value : 0

### guard

    “guard” GstDvbSrcGuard *

(DVB-T) Guard Interval

Flags : Read / Write

Default value : 16 (1)

### hierarchy

    “hierarchy” GstDvbSrcHierarchy *

(DVB-T) Hierarchy information

Flags : Read / Write

Default value : 1 (1)

### interleaving

    “interleaving” GstDvbSrcInterleaving *

(DTMB) Interleaving type

Flags : Read / Write

Default value : auto (1)

### inversion

    “inversion” GstDvbSrcInversion *

(DVB-T and DVB-C) Inversion information

Flags : Read / Write

Default value : on (1)

### isdbt-layer-enabled

    “isdbt-layer-enabled” guint

(ISDB-T) Layer Enabled (7 = All layers)

Flags : Read / Write

Default value : 7

### isdbt-layera-fec

    “isdbt-layera-fec” GstDvbSrcCode_Rate *

(ISDB-T) layer A Forward Error Correction

Flags : Read / Write

Default value : auto (9)

### isdbt-layera-modulation

    “isdbt-layera-modulation” GstDvbSrcModulation *

(ISDB-T) Layer A modulation type

Flags : Read / Write

Default value : auto (6)

### isdbt-layera-segment-count

    “isdbt-layera-segment-count” gint

(ISDB-T) Layer A segment count (-1 = AUTO)

Flags : Read / Write

Default value : -1

### isdbt-layera-time-interleaving

    “isdbt-layera-time-interleaving” gint

(ISDB-T) Layer A time interleaving (-1 = AUTO)

Flags : Read / Write

Default value : -1

### isdbt-layerb-fec

    “isdbt-layerb-fec” GstDvbSrcCode_Rate *

(ISDB-T) layer B Forward Error Correction

Flags : Read / Write

Default value : auto (9)

### isdbt-layerb-modulation

    “isdbt-layerb-modulation” GstDvbSrcModulation *

(ISDB-T) Layer B modulation type

Flags : Read / Write

Default value : auto (6)

### isdbt-layerb-segment-count

    “isdbt-layerb-segment-count” gint

(ISDB-T) Layer B segment count (-1 = AUTO)

Flags : Read / Write

Default value : -1

### isdbt-layerb-time-interleaving

    “isdbt-layerb-time-interleaving” gint

(ISDB-T) Layer B time interleaving (-1 = AUTO)

Flags : Read / Write

Default value : -1

### isdbt-layerc-fec

    “isdbt-layerc-fec” GstDvbSrcCode_Rate *

(ISDB-T) layer C Forward Error Correction

Flags : Read / Write

Default value : auto (9)

### isdbt-layerc-modulation

    “isdbt-layerc-modulation” GstDvbSrcModulation *

(ISDB-T) Layer C modulation type

Flags : Read / Write

Default value : auto (6)

### isdbt-layerc-segment-count

    “isdbt-layerc-segment-count” gint

(ISDB-T) Layer C segment count (-1 = AUTO)

Flags : Read / Write

Default value : -1

### isdbt-layerc-time-interleaving

    “isdbt-layerc-time-interleaving” gint

(ISDB-T) Layer C time interleaving (-1 = AUTO)

Flags : Read / Write

Default value : -1

### isdbt-partial-reception

    “isdbt-partial-reception” gint

(ISDB-T) Partial Reception (-1 = AUTO)

Flags : Read / Write

Default value : 1

### isdbt-sb-segment-count

    “isdbt-sb-segment-count” guint

(ISDB-T) SB segment count

Flags : Read / Write

Default value : 1

### isdbt-sb-segment-idx

    “isdbt-sb-segment-idx” gint

(ISDB-T) SB segment IDX

Flags : Read / Write

Default value : 0

### isdbt-sb-subchannel-id

    “isdbt-sb-subchannel-id” gint

(ISDB-T) SB Subchannel ID (-1 = AUTO)

Flags : Read / Write

Default value : -1

### isdbt-sound-broadcasting

    “isdbt-sound-broadcasting” gint

(ISDB-T) Sound Broadcasting

Flags : Read / Write

Default value : 0

### lnb-lof1

    “lnb-lof1” guint

LNB's Local oscillator frequency used for low band reception (kHz)

Flags : Read / Write

Default value : 9750000

### lnb-lof2

    “lnb-lof2” guint

LNB's Local oscillator frequency used for high band reception (kHz)

Flags : Read / Write

Default value : 10600000

### lnb-slof

    “lnb-slof” guint

LNB's Upper bound for low band reception (kHz)

Flags : Read / Write

Default value : 11700000

### modulation

    “modulation” GstDvbSrcModulation *

(DVB-T/T2/C/S2, TURBO and ATSC) Modulation type

Flags : Read / Write

Default value : qam-16 (1)

### pids

    “pids” gchararray

Colon-separated list of PIDs (eg. 110:120) to capture. ACT and CAT are automatically included but PMT should be added explicitly. Special value 8192 gets full MPEG-TS

Flags : Read / Write

Default value : 8192

### pilot

    “pilot” GstDvbSrcPilot *

Pilot (DVB-S2)

Flags : Read / Write

Default value : auto (2)

### polarity

    “polarity” gchararray

(DVB-S/S2) Polarity [vhHV] (eg. V for Vertical)

Flags : Read / Write / Construct

Default value : H

### rolloff

    “rolloff” GstDvbSrcRolloff *

Rolloff (DVB-S2)

Flags : Read / Write

Default value : auto (3)

### stats-reporting-interval

    “stats-reporting-interval” guint

The number of reads before reporting frontend stats

Flags : Read / Write

Default value : 100

### stream-id

    “stream-id” gint

(DVB-T2 and DVB-S2 max 255, ISDB max 65535) Stream ID (-1 = disabled)

Flags : Read / Write

Default value : -1

### symbol-rate

    “symbol-rate” guint

(DVB-S/S2, DVB-C) Symbol rate in kBd (kilo bauds)

Flags : Read / Write

Default value : 0

### timeout

    “timeout” guint64

Post a message after timeout microseconds (0 = disabled)

Flags : Read / Write

Default value : 1000000

### trans-mode

    “trans-mode” GstDvbSrcTransmission_Mode *

(DVB-T) Transmission mode

Flags : Read / Write

Default value : 8k (1)

### tune

    “tune” gpointer

Atomically tune to channel. (For Apps)

Flags : Read / Write

### tuning-timeout

    “tuning-timeout” guint64

Microseconds to wait before giving up tuning/locking on a signal

Flags : Read / Write

Default value : 10000000000

## Named constants

### GstDvbSrcBandwidth

#### Members

`8` (0) – 8
`7` (1) – 7
`6` (2) – 6
`AUTO` (3) – AUTO
`5` (4) – 5
`10` (5) – 10
`1.712` (6) – 1.712

### GstDvbSrcCode_Rate

#### Members

`none` (0) – NONE
`1/2` (1) – 1/2
`2/3` (2) – 2/3
`3/4` (3) – 3/4
`4/5` (4) – 4/5
`5/6` (5) – 5/6
`6/7` (6) – 6/7
`7/8` (7) – 7/8
`8/9` (8) – 8/9
`auto` (9) – AUTO
`3/5` (10) – 3/5
`9/10` (11) – 9/10
`2/5` (12) – 2/5

### GstDvbSrcDelsys

#### Members

`undefined` (0) – UNDEFINED
`dvb-c-a` (1) – DVB-C-A
`dvb-c-b` (2) – DVB-C-B
`dvb-t` (3) – DVB-T
`dss` (4) – DSS
`dvb-s` (5) – DVB-S
`dvb-s2` (6) – DVB-S2
`dvb-h` (7) – DVB-H
`isdb-t` (8) – ISDB-T
`isdb-s` (9) – ISDB-S
`isdb-c` (10) – ISDB-C
`atsc` (11) – ATSC
`atsc-mh` (12) – ATSC-MH
`dtmb` (13) – DTMB
`cmmb` (14) – CMMB
`dab` (15) – DAB
`dvb-t2` (16) – DVB-T2
`turbo` (17) – TURBO
`dvb-c-c` (18) – DVB-C-C

### GstDvbSrcGuard

#### Members

`32` (0) – 32
`16` (1) – 16
`8` (2) – 8
`4` (3) – 4
`auto` (4) – AUTO
`128` (5) – 128
`19/128` (6) – 19/128
`19/256` (7) – 19/256
`pn420` (8) – PN420
`pn595` (9) – PN595
`pn945` (10) – PN945

### GstDvbSrcHierarchy

#### Members

`none` (0) – NONE
`1` (1) – 1
`2` (2) – 2
`4` (3) – 4
`auto` (4) – AUTO

### GstDvbSrcInterleaving

#### Members

`none` (0) – NONE
`auto` (1) – AUTO
`240` (2) – 240
`720` (3) – 720

### GstDvbSrcInversion

#### Members

`off` (0) – OFF
`on` (1) – ON
`auto` (2) – AUTO

### GstDvbSrcModulation

#### Members

`qpsk` (0) – QPSK
`qam-16` (1) – QAM 16
`qam-32` (2) – QAM 32
`qam-64` (3) – QAM 64
`qam-128` (4) – QAM 128
`qam-256` (5) – QAM 256
`auto` (6) – AUTO
`8vsb` (7) – 8VSB
`16vsb` (8) – 16VSB
`8psk` (9) – 8PSK
`16apsk` (10) – 16APSK
`32apsk` (11) – 32APSK
`dqpsk` (12) – DQPSK
`qam-4-nr` (13) – QAM 4 NR

### GstDvbSrcPilot

#### Members

`on` (0) – ON
`off` (1) – OFF
`auto` (2) – AUTO

### GstDvbSrcRolloff

#### Members

`35` (0) – 35
`20` (1) – 20
`25` (2) – 25
`auto` (3) – auto

### GstDvbSrcTransmission_Mode

#### Members

`2k` (0) – 2K
`8k` (1) – 8K
`auto` (2) – AUTO
`4k` (3) – 4K
`1k` (4) – 1K
`16k` (5) – 16K
`32k` (6) – 32K
`c1` (7) – C1
`c3780` (8) – C3780

The results of the search are